# Method: lookupByExternalId

- [HTTP request](https://developers.google.com/display-video/out-of-home-seller/reference/rest/v1beta1/TopLevel/lookupByExternalId#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/display-video/out-of-home-seller/reference/rest/v1beta1/TopLevel/lookupByExternalId#body.request_body)
  - [JSON representation](https://developers.google.com/display-video/out-of-home-seller/reference/rest/v1beta1/TopLevel/lookupByExternalId#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/display-video/out-of-home-seller/reference/rest/v1beta1/TopLevel/lookupByExternalId#body.response_body)
  - [JSON representation](https://developers.google.com/display-video/out-of-home-seller/reference/rest/v1beta1/TopLevel/lookupByExternalId#body.GetByExternalIdResponse.SCHEMA_REPRESENTATION)
- [Authorization Scopes](https://developers.google.com/display-video/out-of-home-seller/reference/rest/v1beta1/TopLevel/lookupByExternalId#body.aspect)
- [Examples](https://developers.google.com/display-video/out-of-home-seller/reference/rest/v1beta1/TopLevel/lookupByExternalId#examples)

Retrieves all entities by external id listed in the request.

- Returns error code `NOT_FOUND` if any ids do not match an asset.
- Returns error code `FAILED_PRECONDITION` if multiple entities with the same external id are found.

### HTTP request

`POST https://dv360outofhomeseller.googleapis.com/v1beta1:lookupByExternalId`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "lineExternalIds": [ string ], "orderExternalIds": [ string ], "productExternalIds": [ string ], "adUnitExternalIds": [ string ], "creativeAssetsExternalIds": [ string ], "assignmentsExternalIds": [ string ] } ``` |

| Fields ||
|---|---|
| `lineExternalIds[]` | `string` The external ids to fetch names for from Lines table. |
| `orderExternalIds[]` | `string` The external ids to fetch names for from Orders table. |
| `productExternalIds[]` | `string` The external ids to fetch names for from Products table. |
| `adUnitExternalIds[]` | `string` The external ids to fetch names for from AdUnits table. |
| `creativeAssetsExternalIds[]` | `string` The external ids to fetch names for from CreativeAsset table. |
| `assignmentsExternalIds[]` | `string` The external ids to fetch names for from Assignments table. |

### Response body

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "lines": { string: string, ... }, "orders": { string: string, ... }, "products": { string: string, ... }, "adUnits": { string: string, ... }, "creativeAssets": { string: string, ... }, "assignments": { string: string, ... } } ``` |

| Fields ||
|---|---|
| `lines` | `map (key: string, value: string)` Map of external ids to line names. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `orders` | `map (key: string, value: string)` Map of external ids to order names. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `products` | `map (key: string, value: string)` Map of external ids to product names. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `adUnits` | `map (key: string, value: string)` Map of external ids to ad unit names. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `creativeAssets` | `map (key: string, value: string)` Map of external ids to creative asset names. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `assignments` | `map (key: string, value: string)` Map of external ids to assignment names. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |

### Authorization Scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/doubleclickbidmanager`

For more information, see the [OAuth 2.0 Overview](https://developers.google.com/identity/protocols/OAuth2).